#include <bits/stdc++.h>

using namespace std;

#define int long long

int MAX = 1e15;

struct edge{
	int b, t;
};

int dfs(int pos, int target, vector<vector<edge> > &graph, vector< vector<int> > &dist, bool isMin){

	if(dist[pos][target] != -1) return dist[pos][target];

	if(pos == target) return dist[target][target] = 0;

	int sol = -1;
	if(isMin) sol = MAX;

	for(edge neigh: graph[pos]){
		int d = dfs(neigh.b, target, graph, dist, isMin) + neigh.t;

		d = min(d, MAX);

        if(d != MAX){
    		if(isMin){
    			sol = min(sol, d);
    		}else{
    			sol = max(sol, d);
    		}
        }
	}

	if(sol == -1) sol = MAX;

	return dist[pos][target] = sol;
}

signed main() {
    
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    
    int N, K, M; cin >> N >> K >> M;

    vector<vector<edge> > slopes(N), cable(N);

    for(int m=0; m<K; m++){
    	int a, b, t; cin >> a >> b >> t;

    	cable[a].push_back(edge{b, t});
    }

    for(int m=0; m<M; m++){
    	int a, b, t; cin >> a >> b >> t;

    	slopes[a].push_back(edge{b, t});
    }

    int maxP = -1, maxQ = -1, maxC = 1, maxS = 0;

    //precompute distances
    vector< vector<int> > cable_dist(N, vector<int>(N, -1));
    vector< vector<int> > ski_dist(N, vector<int>(N, -1));

    for(int target = 0; target < N; target++){
        for(int start = 0; start < N; start++){
        	dfs(start, target, cable, cable_dist, true);
        	dfs(start, target, slopes, ski_dist, false);
        }
    }

    for(int p = 0; p < N; p++){
    	for(int q = 0; q < N; q++){

    		int C = cable_dist[p][q];

    		int S = ski_dist[q][p];

    		//S/C > maxS/maxC ?
    		if(S < MAX && C < MAX && S*maxC > maxS*C){
    			maxS = S;
    			maxC = C;
    			maxP = p;
    			maxQ = q;
    		}
    	}
    }

    if(maxP == -1){
    	cout << "None" << "\n";
    }else{
    	cout << maxP << " " << maxQ << " " << maxC << " " << maxS << "\n";
    }

}
