// score: 50
#include <bits/stdc++.h>
using namespace std;

using ll = int64_t;

template<typename S>
void xmin(S&a, S const&b){
    a = min(a, b);
}

int n;

constexpr ll inf = 1e18;


ll steps = 0;
vector<vector<ll> > calc_dist(vector<vector<pair<int, int> > > const&g){
    vector<vector<ll> > ret(n, vector<ll>(n, inf));
	vector<bool> in_q(n);
	vector<int> q(n*n/2);
	for(int i=0;i<n;++i){
		//q.emplace(i);
		int p = 0, p_r = 0;
		q[p_r++] = i;
		//q.push_back(i);
		ret[i][i] = 0;
		while(p < p_r){
		//while(!q.empty()){
			++steps;
			//int u  = q.front(); q.pop();
			int u  = q[p++];
			in_q[u] = 0;
			for(auto &e:g[u]){
				auto cand = ret[i][u] + e.second;
				if(ret[i][e.first] > cand){
					ret[i][e.first] = cand;
					if(!in_q[e.first]){
						q[p_r++] = e.first;
						//q.emplace_back(e.first);
						in_q[e.first] = 1;
					}
				}
			}
		}
		//q.clear();
	}
	cerr << "Steps: " << steps << "\n";
    return ret;
}

struct Cand{
    int u, v;
    ll d_cable, d_slope;
    // check if *this is worse that o
    bool operator<(Cand const&o) const {
        return d_cable*o.d_slope > d_slope*o.d_cable;
    }
    bool valid() const {
        return u!=v && abs(d_cable) < inf/2 && abs(d_slope) < inf/2;
    }
};

signed main(){
    cin.exceptions(ios::failbit | ios::badbit | ios::eofbit);
    cin.tie(0); ios_base::sync_with_stdio(false);

    array<int, 2> m;
    cin >> n >> m[0] >> m[1];

    array<vector<vector<pair<int, int> > >, 2> gs;
    for(auto &e:gs) e.resize(n);
    array<vector<vector<ll> >, 2> dists;

    for(int it=0;it<2;++it){
        for(int i=0;i<m[it];++i){
            int a, b, w;
            cin >> a >> b >> w;
            gs[it][a].emplace_back(b, it==0 ? w : -w);
        }
        dists[it] = calc_dist(gs[it]);
    }
    vector<Cand> cands;

    for(int i=0;i<n;++i){
        for(int j=0;j<n;++j) if(j!=i){
            Cand c{i, j, dists[0][i][j], -dists[1][j][i]};
            if(c.valid()){
                if(!cands.empty() && cands[0] < c){
                    cands.clear();
                }
                if(cands.empty() || !(c < cands[0])){
                    cands.push_back(c);
                }
            }
        }
    }
    if(cands.empty()){
        cout << "None\n";
    } else {
        auto const&e = cands.back();
        cout << e.u << " " << e.v << " " << e.d_cable << " " << e.d_slope << "\n";
    }

}
