// score: 50
#include<iostream>
#include<vector>
#include<functional>

# define inf (1e9)
using namespace std;

int N, K, M;

int main(void) {
  int a, b, c;
  cin >> N >> K >> M;
  vector<vector<int> > slopes(N, vector<int>(N, -inf));
  vector<vector<int> > cablecars(N, vector<int>(N, inf));

  for(int i=0; i<K; ++i) {
    cin >> a >> b >> c;
    //--a; --b;
    cablecars[a][b] = min(cablecars[a][b], c);
  }
  for(int i=0; i<M; ++i) {
    cin >> a >> b >> c;
    //--a; --b;
    slopes[a][b] = max(slopes[a][b], c);
  }

  for(int k=0; k<N; ++k)
    for(int i=0; i<N; ++i)
      for(int j=0; j<N; ++j) {
        cablecars[i][j] = min(cablecars[i][j], cablecars[i][k] + cablecars[k][j]);
        slopes[i][j] = max(slopes[i][j], slopes[i][k] + slopes[k][j]);
      }

  int best_p = -1, best_q = -1, best_ts = 1, best_tc = inf;
  for(int p=0; p<N; ++p)
    for(int q=0; q<N; ++q){
	  if(cablecars[p][q] == inf || slopes[q][p] == -inf) continue;
      if ((long long)cablecars[p][q] * (long long)best_ts < (long long)slopes[q][p] * (long long)best_tc) {
        best_p = p;
        best_q = q;
        best_ts = slopes[q][p];
        best_tc = cablecars[p][q];
	}}
  if (best_p == -1 || best_q == -1) cout << "None" << endl;
  else cout << best_p/*+1*/ << " " << best_q/*+1*/ << " " << best_tc << " " << best_ts << endl;
  return 0;
}
