// score:  40
// optimizes max and min separately
// should only work for k=1

#include <bits/stdc++.h>
using namespace std;

using ll = int64_t;

template<typename T>
void xmin(T&a, T const&b){
    a = min(a, b);
}

template<typename T>
void xmax(T&a, T const&b){
    a = max(a, b);
}


constexpr ll inf = 1e18;

signed main(){
    int n, k;
    cin >> n >> k;
    vector<int> v(n);
    for(auto &e:v) cin >> e;
    
    vector<ll> pre(n+1, 0);
    for(int i=0;i<n;++i){
        pre[i+1] = pre[i] + v[i];
    }
    pre.emplace_back(inf);
    auto next_non_smaller = [&](ll x){
        return lower_bound(pre.begin(), pre.end(), x) - pre.begin();
    };
    ll low, high;
    {
        ll l=0, r=pre[n]+1;
        while(l+1 < r){
            ll m = l + (r-l)/2;
            int a = 0;
            for(int it=0;it<=k;++it){
                a = next_non_smaller(pre[a] + m);
                if(a > n) break;
            }
            if(a>n){
                r = m;
            } else {
                l=m;
            }
        }
        low = l;
    }
    {
        ll l=low-1, r=pre[n]+1;
        while(l+1 < r){
            ll m = l + (r-l)/2;
            int a = 0;
            for(int it=0;it<=k;++it){
                a = next_non_smaller(pre[a] + m+1)-1;
            }
            if(a>=n){
                r = m;
            } else {
                l=m;
            }
        }
        high = r;
    }
    cout << high-low << "\n";
}
